/*
 *  iReport  --  Visual designer for generating JasperReports Documents
 *  Copyright (C) 2002  Giulio Toffoli gt@businesslogic.it
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Giulio Toffoli
 *  Via T.Aspetti, 233
 *  35100 Padova ITALY
 *  gt@businesslogic.it
 */
package com.businesslogic.ireport;

import java.util.*;
public class UndoOperation
{
	public int type;
	public Vector params;
	
	public UndoOperation(int type)
	{
		this.type = type;
		params = new Vector();
	}
	
	public String toString()
	{
		if (type == UndoOperationType.UNDO_DELETE) 
			return "delete";
		else if (type == UndoOperationType.UNDO_TRANSFORMATION) 
			return "transformation";
		else if (type == UndoOperationType.UNDO_INSERT) 
			return "insert";
		else
			return "";
	}
}
